#!/usr/bin/perl -w
use strict;												
use Getopt::Long;		
use File::Basename qw(basename dirname);   

my $BEGIN_TIME=time();	   
my $version="1.0.0";		
#######################################################################################

my ($infile1,$outfile,$infile2,$infile3);	
GetOptions(		
				"help|?" =>\&USAGE,			
				"i1:s"=>\$infile1,	
				"i2:s"=>\$infile2,
				"i3:s"=>\$infile3,
				"o:s"=>\$outfile,
				) or &USAGE;
&USAGE unless ($infile3 and $infile1 and $infile2 and $outfile);

#######################################################################################
# ------------------------------------------------------------------
# Main Body                 
# ------------------------------------------------------------------
open IN,$infile1 or die"$!";
my @gene_name;

while(<IN>){
	chomp;
	next if (/^#|^\s*$/);
	push @gene_name ,(split)[0]; 	#һ
}close IN;



my %for_start_and_end;
open IN,$infile2 or die"$!";
while(<IN>){
	chomp;
	next if(/^#|^\s*$/);

	if((split)[2] eq "mRNA"){
		if(/ID=(.*?);/){
			my $name = $1;
			$name =~ s/.*?://g;

			if(defined $for_start_and_end{$name}){		#жѡ񳤵		
				if(${$for_start_and_end{$name}}[1] - ${$for_start_and_end{$name}}[0] > (split)[4] - (split)[3]){
					1;
				}else{
					$for_start_and_end{$name} = [(split)[3],(split)[4],(split)[0],(split)[6]] ;
				}
			}else{
				$for_start_and_end{$name} = [(split)[3],(split)[4],(split)[0],(split)[6]] ;
			}
		}
	}
}close IN;



open IN,$infile3 or die"";
my %for_chr_seq;
my $chr_name;
while(<IN>){
	chomp;
	if ( /^>([\S]+)/){
		$chr_name = $1;
	}else{
		s/\s+//g;
		$for_chr_seq{$chr_name} .= $_;
	}
}

open OUT ,">$outfile" or die;
for my $gene_name(@gene_name){
	print"$gene_name\n";
	unless($for_start_and_end{$gene_name}){
		print"##WARN: not find $gene_name seq\n";
		next;
	}

	if($for_start_and_end{$gene_name}->[3] eq "+"){  #
		my $seq = substr($for_chr_seq{$for_start_and_end{$gene_name}->[2]},$for_start_and_end{$gene_name}->[0]-2000-1,2000);	
		#gene2000bpУ$for_start_and_end{$gene_name}->[0]-2000-1 geneε㣬2000ĳ
		print OUT ">$gene_name\n$seq\n";
	}elsif($for_start_and_end{$gene_name}->[3] eq "-"){	#Ҫ򻥲£ȡĩ˵
		my $seq = substr($for_chr_seq{$for_start_and_end{$gene_name}->[2]},$for_start_and_end{$gene_name}->[1],2000);
		$seq = reverse $seq;
		$seq =~ tr/ACGTacgt/TGCAtgca/;
		print OUT ">$gene_name\n$seq\n";
	}else{
		print "$gene_name chain maybe wrong\n";
	}
}

#######################################################################################
print "\nDone. Total elapsed time : ",time()-$BEGIN_TIME,"s\n"; 
#######################################################################################

# ------------------------------------------------------------------
sub USAGE {         
	my $usage=<<"USAGE";				
Program: 
Version: $version
Contact: xul<xul\@genepioneer.cn> <1275875706\@qq.com>
Description: 
Usage:
  Options:
	-i1	gene name list
	-i2	gff
	-i3	genome_chr.fa
	-o	<outfile>	output file, 
	-h				Help

USAGE
	print $usage;
	exit;
}
